#include "sample.h"


int main(int carg, char **szarg){
    int cDevice;
    int cChannel;
    double hzFreq;
    char szDeviceName[32];
    char szSN[32];
    BOOL fIsInUse;
    HDWF hdwf;

    // detect connected all supported devices
    FDwfEnum(enumfilterAll, &cDevice);
    // list information about each device
    printf("found %d devices\n", cDevice);
    for(int i = 0; i < cDevice; i++){
        // we use 0 based indexing
        FDwfEnumDeviceName (i, szDeviceName);
        FDwfEnumSN(i, szSN);
        printf("device: %d name: %s %s\n", i+1, szDeviceName, szSN);
        // before opening, check if the device isnt already opened by other application, like: WaveForms
        FDwfEnumDeviceIsOpened(i, &fIsInUse);
        if(!fIsInUse){
            FDwfDeviceOpen(i, &hdwf);
            FDwfAnalogInChannelCount(hdwf, &cChannel);
            FDwfAnalogInFrequencyInfo(hdwf, NULL, &hzFreq);
            printf("number of analog input channels: %d maximum freq.: %.0f Hz\n", cChannel, hzFreq);
            FDwfDeviceClose(hdwf);
            hdwf = hdwfNone;
        }
    }
    // before application exit make sure to close all opened devices by this process
    FDwfDeviceCloseAll();
}